'collision module
'Relsoft 2005
'Rel.Betterwebber.com

declare function collide_spr ( byval sx1, byval sy1, byval image1 as ushort ptr,_
		 			   		   byval sx2, byval sy2, byval image2 as ushort ptr ) as integer

'************************************************************************
':::: checks whether a sprite collides with another sprite
':::: Pixel perfect

function collide_spr ( byval sx1, byval sy1, byval image1 as ushort ptr,_
		 			   byval sx2, byval sy2, byval image2 as ushort ptr ) as integer


	dim x1 as integer, y1 as integer
	dim x2 as integer, y2 as integer
	dim wid1 as integer
	dim hei1 as integer
	dim wid2 as integer
	dim hei2 as integer
	dim wid2_clip as integer
	dim offset_add as integer
	dim retval as ushort

	x1 = sx1
	y1 = sy1
	x2 = sx2
	y2 = sy2

	'esi          =image1
	'edi          =image2

	'ebx=width
	'edx=height

  asm
	 		   	  		 	  'calculate the coordinates
	mov eax, [x1]    		  'x1
	mov ebx, [x2]  			  'x2
	sub eax, ebx    		  'x1-x2
	mov [x1], eax

	mov ecx, [y1]  			  'y1
	mov edx, [y2]  			  'y2
	sub ecx, edx       		  'x1-x2
	mov [y1], ecx

	mov esi, [image1]  		  'we are now on the width of the spr1 w=(array(0)/8)-1
	mov edi, [image2]   	  'spr2 off
	xor ebx, ebx			  'zero out ebx
	mov bx,  [esi]  		  'width*8 of  spr1

	shr ebx,3        		  'div width by 8
	xor edx, edx			  'zero out edx
	mov dx,  [esi+2]   		  'save height spr1
	mov [wid1], ebx			  'save wid1
	add esi,4        		  'si now points to 1st color of spr1 array
	mov [hei1], edx			  'save height

	xor ecx, ecx
	mov cx, [edi]  			  'spr2 width*8
	xor eax, eax
	mov ax, [edi+2]			  'spr2 height
	shr ecx, 3        		  'div 8
	dec ecx          		  'correct it
	dec eax
	mov [wid2], ecx			  'wid 2
	mov [hei2], eax			  'hei 2
	add edi, 4

	'note!!!!  after the clips
	'eax=x     clipped
	'ecx=y     clipped
	'ebx=width   new
	'edx=height  new

	        mov eax, [x1]            'x1 value
	        cmp eax, [wid2]          'get out if x1 > spr2w
			jg lbl_end_it            'else

	        cmp eax, 0               'x<0 then
	        jl lbl_clip_left         'clip our x value

	lbl_post_clip_left:

	        mov ecx, [y1]          	 'y1 value
	        cmp ecx, [hei2]          'get out if y1 > spr2h
			jg lbl_end_it            'else

	        cmp ecx, 0               'y<0 then
	        jl lbl_clip_top          'clip our y value

	lbl_post_clip_top:

	'ok here's the score: eax=x,ecx=y,edx=height,ebx=width
	'all clipped top and left
	'now lets clip it to the right

	        add ebx, eax               'add x to width and see if its over  *bx is destroyed
	        cmp ebx, [wid2]            'if x+width > destw 'too right then crop it
	        jg  lbl_clip_right         'else continue
	        sub ebx, eax               'restore bx since it was destroyed

	lbl_post_clip_right:

	'now lets clip it down

	        add edx, ecx               'add y to height and see if its over  *dx is destroyed
	        cmp edx,[hei2]             'if y+height > desth 'too low then crop it
	        jg  lbl_clip_down          'else continue
	        sub edx, ecx               'restore dx since it was destroyed

	lbl_post_clip_down:


	'whew!!!!!!!!! that was disorienting!!!!!!!!
	'but all variables are either clipped or cropped now   '-)
	'eax=x,ecx=y,ebx=width,edx=height
	'edi=y*destwidth+1+x


	mov [hei1], ebx   'damn full of agi's here :(    save bx/clippped width
	mov ebx, [wid2]
	inc ebx
	imul ecx, ebx
	sub ebx, [hei1]
	mov [wid2_clip], ebx   'save destw+1-width to stack


	'let us now calculate  the offset normally

	add edi, ecx       'save y value to dx
	add edi, eax       'dest offset(x,y)=y*destw+1+x


	mov ebx, [hei1]   'restore bx

	lbl_main_spr_loop:

	mov ecx, ebx               	 		'put clipped width to counter

	lbl_sprite_loop:                	'x loop

	        mov al, [esi]          		'mov color
	        inc esi                  	'next offset

	        or al, al                	'if c<>0 then

	        jz lbl_skip_0           	'else
	           mov ah, [edi]       		'store spr2 color to ah
	           cmp ah, 0             	'check if its zero
	           jne lbl_collide_true 	'collide if not zero
	        lbl_skip_0:

	        inc edi

	        dec ecx

	jnz   lbl_sprite_loop

	add edi, [wid2_clip]                'add to di our destw+1-clp_width
	add esi, [offset_add]               'corrector point to next row

	dec edx

	jnz  lbl_main_spr_loop


	lbl_end_it:
	sub eax, eax
	jmp lbl_get_out

	lbl_collide_true:
	xchg ah,al
	sub ah,ah
	jmp lbl_get_out


	lbl_clip_left:
	        neg eax          			'negate ax ax=-ax=+ax
	        sub ebx, eax       			'subract clipped width to real width
	        jle lbl_end_it  			'if ax<=0 then endit since its tooleft to see a col of pix ')
	        add esi, eax       			'add our ax to si(point to clipped x offset
	                        			'bx is our new clipped width
	        mov [offset_add], eax   	'save it to stack for skipping check purposes

	        xor eax, eax       			'zero is our x coord
	jmp lbl_post_clip_left



	lbl_clip_top:
	        neg ecx          			'negate cx cx=-cx=+cx
	        sub edx, ecx       			'subract clipped height to real height
	                        			'dx is our new clipped height
	        jle lbl_end_it  			'if cx<=0 then endit since its tooleft to see a row of pix ')

	     lbl_height_loop:
	        add esi, [wid1]   			'add our real width to si(point to clipped y offset)
	        dec ecx
	     jnz lbl_height_loop        	'loop it until we get to right y offset
	                                	'cx=0 zero is our y coord
	jmp lbl_post_clip_top


	lbl_clip_right:
	       sub ebx, [wid2]   			'subtract x+width with destw  trust me no negs here :)
	       dec ebx           			'bx now is clipped right
	       add [offset_add], ebx    	'add it to the checker as our spr data is in column major order
	       mov ebx,[wid2]    			'correct bx to  clipx2+1
	       inc ebx
	       sub ebx, eax        			'subtract ax to bx to correct width (0 to destw)
	jmp lbl_post_clip_right

	lbl_clip_down:
	       add ecx, edx        			'add the height to y
	       sub ecx, [hei2]   			'correct it
	       dec ecx
	       sub edx, ecx        			'crop our height
	       mov ecx, [y1]   				'restore y
	jmp lbl_post_clip_down

	lbl_get_out:
	  	  mov [retval], ax

  end asm

  collide_spr = retval

end function





